<div class="wrapper">
    <!-- <div *ngFor="let roleLocation of roleLocations; index as i"> -->
    <form [formGroup]="roleAndLoactionForm">
        <div class="row" formArrayName="roleLocationArray" *ngFor="let roleAndLocation of getRoleandLocationArray(roleAndLoactionForm); let i = index">
            <div class="row" [formGroupName]="i">

                <div class="col-xl-4">
                    <!-- <h5 class="bold mt-4 mb-4 black" *ngIf="i === 0">
                    {{ roleLocation.location ? roleLocation.location.locationName : '' }}</h5> -->
                    <!-- *ngIf="roleLocation && i > 0" -->
                    <div class="normal_13px_15px_font text-right normalhelfont grey caser">
                        Required
                    </div>
                    <!-- *ngIf="roleLocation && i > 0" -->
                    <mat-form-field [appearance]="apperance" class="full-width">
                        <mat-label>Location </mat-label>
                        <mat-icon class="blue-icon" matSuffix>search</mat-icon>
                        <mat-select formControlName="location" required [disabled]="roleAndLocation.get('location')?.value != ''">
                            <mat-option *ngFor="let location of locationList;let i=index;" [value]="location.id" (click)="selectedLocation(location,i)" [disabled]="location.disabled">
                                {{ location.locationName }}
                            </mat-option>
                        </mat-select>
                        <mat-error *ngIf="roleAndLocation.get('location')?.hasError('required') && roleAndLocation.get('location').touched">
                            Location is required.
                        </mat-error>
                    </mat-form-field>

                </div>
                <div class="col-xl-8">
                    <div class="normal_13px_15px_font text-right normalhelfont grey caser">
                        Required
                    </div>
                    <kendo-multiselect [data]="roles" placeholder="Role" [textField]="'roleName'" [valueField]="'id'" formControlName="role" (valueChange)="roleChanged($event, roleAndLocation)">
                    </kendo-multiselect>
                    <!-- <mat-form-field [appearance]="apperance" class="full-width mr-2" id="field">
              <mat-label>Role</mat-label>
              <div class="material-icons" style="position: absolute;right: 0;color: #00AEEF;">
                  search
              </div>
              <div class="material-icons" style="position: absolute;right: -17px;color: #00AEEF;">
                  arrow_drop_down
              </div>
              <input matInput (keyup)="handleFilterRole($event)" autocomplete="off" [matAutocomplete]="auto" formControlName="role" required>
              <mat-autocomplete #auto="matAutocomplete">
                  <mat-option *ngFor="let role of rolesSearchList" [value]="role.id">
                      {{role.roleName}}
                  </mat-option>
              </mat-autocomplete>
          </mat-form-field> -->
                </div>
                <div class="col-xl-12">
                    <h5 class="bold black">Scheduler Access</h5>
                    <div class="row">
                        <div class="col-xl-12">
                            <kendo-multiselect placeholder="Scheduler Access" [textField]="'firstName'" [valueField]="'id'" [data]="practitioners" formControlName="practitioner">
                            </kendo-multiselect>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xl-12">
                            <p style="font-size: 12px;
                            color: grey;">
                                Only the selected Practitioner's bookings will be shown in your Appointment Scheduler.
                            </p>
                        </div>
                    </div>
                </div>
                <div class="w-100" *ngFor="let item of roleAndLocation.get('role')?.value;let j=index;">
                    <div class="col-xl-12 mt-2" *ngIf="item.roleName == 'Practitioner'">
                        <div>
                            <div class="detail-wrap mb-2">
                                <div>
                                    <h5 class="black">Practitioner Details</h5>
                                </div>
                                <div class="c-point" *ngIf="roleAndLocation.get('specialities')?.value?.length != 0">
                                    <a (click)="openPopup('addOtherIds',i);">
                                        <b>
                      <h6 class="bold custom-title">Add Other ID's</h6>
                    </b>
                                    </a>
                                </div>
                            </div>
                            <div class="row" style="align-items: baseline;">
                                <div class="col-xl-6">
                                    <div class="row">
                                        <div class="col-xl-12 d-flex justify-content-end">
                                            <span class="hazel-text"></span>
                                        </div>
                                        <div class="col-xl-12 d-flex align-items-center" style="top: 5px;">
                                            <mat-form-field [appearance]="apperance" class="full-width">
                                                <mat-label>Service Type </mat-label>
                                                <mat-select formControlName="serviceType">
                                                    <mat-option *ngFor="let service of serviceType" [value]="service.id">
                                                        {{ service.serviceName }}
                                                    </mat-option>
                                                </mat-select>
                                            </mat-form-field>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xl-6">
                                    <div class="row">
                                        <div class="col-xl-12 d-flex justify-content-end">
                                            <span class="hazel-text">Required</span>
                                        </div>
                                        <div class="col-xl-12 d-flex align-items-center">
                                            <kendo-multiselect [data]="specialities" placeholder="Speciality" [textField]="'specialityName'" [valueField]="'id'" formControlName="specialities" (valueChange)="changeSpecialityType($event,i)">
                                            </kendo-multiselect>
                                        </div>
                                        <span class="error-message" *ngIf="roleAndLocation.get('specialities')?.hasError('required') && roleAndLocation.get('specialities')?.touched">
                      Speciality is required.
                    </span>
                                    </div>
                                </div>
                            </div>
                            <div class="c-center">
                                <div class="w-100" formArrayName="otherSpecialityArray" *ngFor="let otherSpeciality of getotherSpecialityArrayControl(roleAndLocation,i); let k = index">
                                    <div [formGroupName]="k" class="col-xl-12">
                                        <div class="row">
                                            <div class="col-xl-6 pl-0" style="top: 15px;">
                                                <mat-form-field [appearance]="apperance" class="full-width">
                                                    <mat-label>Speciality</mat-label>
                                                    <input matInput placeholder="Speciality" type="text" formControlName="name" autocomplete="off" required readonly>
                                                </mat-form-field>
                                            </div>
                                            <div class="col-xl-6 pr-0">
                                                <div class="normal_13px_15px_font text-right normalhelfont grey caser">
                                                    Required
                                                </div>
                                                <mat-form-field [appearance]="apperance" class="full-width">
                                                    <mat-label>Provider Number</mat-label>
                                                    <input matInput placeholder="Provider Number" type="text" formControlName="provider_no" required autocomplete="off" maxlength="6">
                                                    <mat-error *ngIf="otherSpeciality.get('provider_no').hasError('required') &&  otherSpeciality.get('provider_no').touched">
                                                        Provider number is required.
                                                    </mat-error>
                                                </mat-form-field>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-xl-12">
                    <div class="d-flex justify-content-start">
                        <div class="d-flex mt-2 mb-3 c-remove" *ngIf="i > 0" style="align-items: center;">
                            <mat-icon class="default-icon blue-icon">remove_circle</mat-icon>
                            <a (click)="openPopup('deleteOtherLocation',i)" style="font-weight: 600;">
                Remove
                Location
              </a>
                        </div>
                    </div>
                </div>
                <div class="col-xl-12">
                    <div class="d-flex justify-content-end mt-10 mb-3" *ngIf="locationList && (i < locationList.length - 1) && i == roleLocations.length -1">
                        <button mat-stroked-button color="accent" (click)="addRoleLocation();">
              Assign
              another
              Location
            </button>
                    </div>
                </div>
            </div>
        </div>
    </form>

    <!-- </div> -->
    <!-- common popup start-->
    <kendo-dialog *ngIf="showPopup" (close)="closePopups(whichPopup)" [height]="auto" [width]="800" autoFocusedElement="#nocancel">
        <div class="modalHeight">
            <div class="col-xl-12 p-0">
                <div class="custom-delete-modal">
                    <span class="QUI_BOLD_18_32 deletetext text-uppercase">
            <span *ngIf="whichPopup == 'deleteOtherLocationError'">
              <img src="../../../../../assets/error_info.svg">
            </span>
                    <span>
              {{popupHeaderTitle}}
            </span>
                    </span>
                    <button mat-icon-button (click)="closePopups(whichPopup)" aria-label="Close dialog">
            <mat-icon>close</mat-icon>
          </button>
                </div>
            </div>
            <mat-divider></mat-divider>
            <div class="deleteDescription">
                <p class="HEL_REG_16_22 patientdeletemodal custom-font lightcolor pt-2">
                    {{popupBodyContent}}
                </p>
                <ul *ngIf="whichPopup == 'deleteOtherLocationError'" class="list-custom p-0">
                    <li class="list-custom"> - {{popupBodyContent1}}</li>
                    <li class="list-custom"> - {{popupBodyContent2}}</li>
                    <li class="list-custom"> - {{popupBodyContent3}}</li>
                    <li class="list-custom"> - {{popupBodyContent4}}</li>
                </ul>
                <div class="HEL_REG_16_22 patientdeletemodal custom-font lightcolor pt-2" *ngIf="whichPopup == 'addOtherIds'">
                    <form [formGroup]="otherInfoRolePermissionForm">
                        <div class="pl-15" formArrayName="otherIdsArray" *ngFor="let fromTo of otherInfoRolePermissionForm.get('otherIdsArray')['controls']; let i=index;">
                            <div class="row" [formGroupName]="i">
                                <div class="col-xl-3">
                                    <mat-form-field [appearance]="apperance" class="full-width">
                                        <mat-label>Speciality </mat-label>
                                        <mat-select formControlName="speciality" [disabled]="fromTo.get('speciality')?.value != ''">
                                            <mat-option *ngFor="let speciality of specialities" [value]="speciality" (click)="selectedSpecialityObj(speciality)">
                                                {{ speciality.specialityName }}
                                            </mat-option>
                                        </mat-select>
                                    </mat-form-field>
                                </div>
                                <div class="col-xl-3">
                                    <mat-form-field [appearance]="apperance" class="full-width">
                                        <mat-label>Name</mat-label>
                                        <!-- <div class="material-icons" style="position: absolute;right: 0;color: #00AEEF;">
                            search
                        </div> -->
                                        <div class="material-icons" style="position: absolute;right: -17px;color: #00AEEF;">
                                            arrow_drop_down
                                        </div>
                                        <input matInput (keyup)="handleFilterName($event)" autocomplete="off" [matAutocomplete]="auto" formControlName="name" required>
                                        <mat-autocomplete #auto="matAutocomplete">
                                            <mat-option *ngFor="let name of otherNameList" [value]="name.name">
                                                {{name.name}}
                                            </mat-option>
                                        </mat-autocomplete>
                                    </mat-form-field>
                                </div>
                                <div class="col-xl-3">
                                    <mat-form-field [appearance]="apperance" class="full-width">
                                        <mat-label>ID No</mat-label>
                                        <input matInput placeholder="ID No" autocomplete="off" type="text" formControlName="id_no" required>
                                    </mat-form-field>
                                </div>
                                <div class="col-xl-3" *ngIf="i != 0 && otherInfoRolePermissionForm.get('otherIdsArray')['controls'].length > 1">
                                    <div class="dash-wrapper" (click)="removeOtherIds(i)">
                                        <img src="../../../assets/dash.png" alt="" />
                                    </div>
                                </div>
                                <div class="row pl-15">
                                    <div class="col-xl-3" [ngClass]="{'hidden': !(i==(otherInfoRolePermissionForm.get('otherIdsArray')['controls'].length-1))}">
                                        <div class="addnewitemdr mb-3" (click)="addOtherIds()">
                                            <img src="../../../assets/Add1.png" alt="" class="" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
            <mat-divider></mat-divider>
            <mat-dialog-content>
                <div class="text-right control-row bottom-btn">
                    <div class="pt-3">
                        <button *ngIf="whichPopup != 'deleteOtherLocationError'" mat-stroked-button color="accent" class="mr-3 footer-btn-customize" (click)="closePopups(whichPopup)" id="nocancel" style="padding: 0 10px">
              <span *ngIf="whichPopup == 'addOtherIds'">
                Cancel
              </span>
              <span *ngIf="whichPopup != 'addOtherIds'">
                No
              </span>
            </button>
                        <button *ngIf="whichPopup != 'deleteOtherLocationError'" mat-raised-button color="accent" class="mr-3 footer-btn-customize" (click)="performAction(whichPopup)" id="nocancel" style="padding: 0 10px;margin-right: 0px !important;">
              <span *ngIf="whichPopup == 'addOtherIds'"> Apply</span>
              <span *ngIf="whichPopup != 'addOtherIds'"> Yes</span>
            </button>
                        <button *ngIf="whichPopup == 'deleteOtherLocationError'" mat-raised-button color="accent" class="mr-3 footer-btn-customize" (click)="closePopups(whichPopup)" id="nocancel" style="padding: 0 10px;margin-right: 0px !important;">
              <span> OK</span>
            </button>
                    </div>
                </div>
            </mat-dialog-content>
        </div>
    </kendo-dialog>
    <!-- common popup end-->
</div>